/*
===========================================================

  WordPress API
  
===========================================================
*/

// NPM
import _ from 'lodash'
import axios from 'axios'
// import Redis from 'ioredis'

/*
-----------------------------------------------------------
  Redis Instance
-----------------------------------------------------------
*/

class WordPress {
  
  constructor(studioStore) {

    // this.studio = _.get(studioStore, 'studio')
    
    this.axios = axios

    this.studio = { 
      wordpress_base_url: 'https://wordpress.kwmr.org'
    }
  }

  base64(str) {
    return Buffer.from(str).toString('base64')
  }

  // /*
  // -----------------------------------------------------------
  //   Redis
  // -----------------------------------------------------------
  // */

  // redis = new Redis()
 
  // /*
  // -----------------------------------------------------------
  //   Cache
  // -----------------------------------------------------------
  // */

  // getCacheKey(url) {
  //   const key = `swss:c:${url}`
  //   return key
  // }

  // async getCache(url) {
  //   const json = await this.redis.get(this.getCacheKey(url))
  //   return JSON.parse(json)
  // }

  // async saveCache(url, data) {
  //   const dataAsJSON = JSON.stringify(data)
  //   return await this.redis.set(this.getCacheKey(url), dataAsJSON)
  // }

  // async deleteCache(url) {
  //   return await this.redis.delete(this.getCacheKey(url))
  // }
  
  /*
  -----------------------------------------------------------
  Routes
  -----------------------------------------------------------
  */

  w(path) {
    return this.studio.wordpress_base_url + path
  }
  
  routes = {

    posts: () => this.w(
      `/wp-json/wp/v2/posts?per_page=20&_embed=author,wp:featuredmedia,wp:term`
    ),
    
    postsById: postId => this.w(
      `/wp-json/wp/v2/posts/${postId}?_embed=author,wp:featuredmedia,wp:term`
    ),
    
    postsByTagId: tagId => this.w(
      `/wp-json/wp/v2/posts?tags=${tagId}`
    ),
    
    postsByCategoryId: categoryId => this.w(
      `/wp-json/wp/v2/posts?categories=${categoryId}`
    ),

    postsByAuthorId: authorId => this.w(
      `/wp-json/wp/v2/posts?author=${authorId}`
    ),
    
    pageBySlug: slug => this.w(
      `/wp-json/wp/v2/pages/?slug=${slug}`
    ),
    
    postsByTerm: term => this.w(
      `/wp-json/wp/v2/search/?subtype=post&search=${term}`
    ),
    
    pagesByTerm: term => this.w(
      `/wp-json/wp/v2/search/?subtype=page&search=${term}`
    ),

    contentByTerm: term => this.w(
      `/wp-json/wp/v2/search/?subtype=page&subtype=post&search=${term}`
    ),

  }

  buildURL(type, id = null){
    
    X('buildURL: type')
    X(type)
    X(this.routes[type])

    const url = this.routes[type](id)

    X('url')
    X(url)

    return url 

  }

  /*
  -----------------------------------------------------------
    Get from WordPress API
  -----------------------------------------------------------
  */

  async getPath(path){

    
    let response = null


    // const cache = await this.getCache(url)


    // X('cache')
    // X(cache)

    // if(cache){
    //   return cache
    // }
    
    // const authHeader = `Basic Q3JlZWtXb3JkUHJlc3NBUEk6eWFRUWs4SkdjcyhKYkNRdCh4ZWJJcnAp`
    // const authHeader = `Basic CreekWordPressAPI:yaQQk8JGcs(JbCQt(xebIrp)`
    // const authHeader = `Basic ` + this.base64('CreekWordPressAPI:yaQQk8JGcs(JbCQt(xebIrp)')
    // const authHeader = `Basic base64encoded ${this.base64('CreekWordPressAPI:yaQQk8JGcs(JbCQt(xebIrp)')}`
    // const authHeader = `Basic base64encoded <${this.base64('CreekWordPressAPI')}:${this.base64('yaQQk8JGcs(JbCQt(xebIrp)')}>`


    let url = this.studio.wordpress_base_url + path


    // console.log(authHeader)

    try{
      response = await axios.get(url, {
        // auth: {
        //   username: 'CreekWordPressAPI',
        //   password: 'yaQQk8JGcs(JbCQt(xebIrp)'
        // },
        // headers: {
        //   'Authorization': authHeader
        // }
      })
    }catch(error){
      console.log('wooooop: ' + url + ' ///// ' + error.message)
      console.log(error.response.data)
    }

    console.log('wooooop: ' + url)
    console.log(response.data)
    
    // if(response.data){
    //   this.saveCache(url, response.data)
    // }

    return response.data

  }

  async get(type, id = null){

    const url = this.buildURL(type, id)

    return await this.getPath(url)

  }

}

/*
-----------------------------------------------------------
  Export
-----------------------------------------------------------
*/

export default WordPress
