import pinia from '~creek-website-toolkit/stores/pinia-init.js'
import { useStudioStore } from '~creek-website-toolkit/stores/StudioStore.js'

export default defineNuxtPlugin(nuxtApp => {

  const studio = {
    studioNameOrDomain: 'kwmr',
    studioId: 5,
    wordpress_base_url: 'https://kwmr.org',
  }


  nuxtApp.studio = studio

  nuxtApp.vueApp.use(pinia)

  const studioStore = useStudioStore()

  nuxtApp.vueApp.studioStore = studioStore

  studioStore.init(studio)
  
  studioStore.setDefaultShowImageUrl('https://spinitron.com/images/Show/25/89/258915-img_show.225x225.png?v=1708632962')

})
